from string import *
from random import *

def shuf(s):
    a = list(s)
    shuffle(a)
    return ''.join(a)

ok = lambda s: all(c1 != c2 for c1, c2 in zip(s, s[1:]))

n, a, b, c = map(int, open('pwgen.in').read().split())
ch = lambda list, n: ''.join(choice(list) for _ in range(n))
while True:
    s = ch(ascii_uppercase, a) + ch(ascii_lowercase, b) + ch(digits, n - a - b)
    s = shuf(s)
    if ok(s):
        print(s, file=open('pwgen.out', 'w'))
        break
